#include "resizable_bitarray.h++"
#include <iostream>
#include <cassert>
#include <climits> // defines CHAR_BIT

int main() {
  std::cout << "Testing Resizable bitarray" << std::endl;

  cphstl::resizable_bitarray<unsigned char> B;
  assert(B.size() == 0);
  B.push_back(true);
  assert(B.size() == 1);
  B.push_back(false);
  assert(B.size() == 2);
  B.push_back(true);
  assert(B.size() == 3);

  assert(B.capacity() == CHAR_BIT * sizeof(unsigned char));

  cphstl::resizable_bitarray<> C;
  assert(C.size() == 0);
  for (int i = 0; i < 1000; ++i) {
    C.push_back(true);
  }
  assert(C.size() == 1000);
  for (int i = 0; i < 1000; ++i) {
    assert(C.get(i) == true);
  }
  for (int i = 0; i < 1000; ++i) {
    C.pop_back();
  }  
  assert(C.size() == 0);
  assert(C.empty());

  cphstl::resizable_bitarray<unsigned char> D(5, 0);
  D.set(0, 4, 10);
  assert(D.get(0, 4) == 10);

  cphstl::resizable_bitarray<unsigned char> E(6, 0);
  E.set(1, 4, 10);
  assert(E.get(1, 4) == 10);

  cphstl::resizable_bitarray<unsigned char> F(10, 0);
  F.set(3, 7, 65);
  assert(F.get(3, 7) == 65);
  F.set(0, 3, 5);
  F.set(10, 4, 8);
  assert(F.get(0, 3) == 5);
  assert(F.get(3, 7) == 65);
  assert(F.get(10, 4) == 8);

  cphstl::resizable_bitarray<unsigned char> G(9, 0);
  G.set(1, 8, 255);
  assert(G.get(1, 8) == 255);

  cphstl::resizable_bitarray<unsigned char> H(15, 0);
  H.set(7, 8, 255);
  assert(H.get(7, 8) == 255);

  std::cout << "Testing OK " << std::endl;
}
