#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n), k(k) {
    a = container(n, element());
    b = container();
    h = container(k, element());
    less = ordering();
  }
  void primal() {
    random_sequence_for_hold(a.begin(), a.end());
    random_sequence_for_hold(h.begin(), h.end());

    binary_heap_ref<element, container, ordering>
      pq(n, less, b);
    for (position i = a.begin(); i != a.end(); ++i) {
      e = *i; 
      pq.push(e); 
    }
    for (unsigned int i = 0; i < k; ++i) {
      e = pq.top() + h[i];
      pq.pop();
      pq.push(e); 
    }
  }
  void dual() {
    // The same without pop() and push()
    random_sequence_for_hold(a.begin(), a.end());
    random_sequence_for_hold(h.begin(), h.end());

    binary_heap_ref<element, container, ordering>
      pq(n, less, b);
    for (position i = a.begin(); i != a.end(); ++i) {
      e = *i; 
      pq.push(e); 
    }
    for (unsigned int i = 0; i < k; ++i) {
      //e = pq.top() + h[i]; No top on empty PQ
    }
  }
private:
  unsigned int n;
  unsigned int k;
  container a; // PQ data
  container b; // PQ
  container h; // hold data
  ordering less;
  element e;
};

