#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n), k(k){
    a = container(n, element());
    b = container(k, element());
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    random_sequence(b.begin(), b.end());

    binary_heap_ref<element, container, ordering>
      pq(k + 1, less, b);

    for (unsigned int i = 0; i < n; ++i) {
      e = a[i];
      pq.push(e);
      pq.pop();
    }
  }

  void dual() {
    random_sequence(a.begin(), a.end());
    random_sequence(b.begin(), b.end());

    binary_heap_ref<element, container, ordering>
      pq(k + 1, less, b);

    for (unsigned int i = 0; i < n; ++i) {
      e = a[i];
    }
  }
private:
  unsigned int n;
  unsigned int k;
  container a;
  container b;
  ordering less;
  element e;
};

