import benchmark
import os
from benchmark_curve_case_hold import *

class plot(benchmark.plot_suite):
  def __init__(self, element, log_i, log_k, k):
    benchmark.plot_suite.__init__(self)
    self.title = 'Efficiency of priority-queue operations: hold model, random doubles' 
    self.xlabel = 'n'
    self.ylabel = 'Execution time per priority-queue operation [in nanoseconds]'
    x = (1 << log_i) - 10
    y = (1 << log_k) + 10
    self.gnuplot_commands += 'set key left top Left reverse samplen 4 spacing 1.25 title "" \n'
    self.gnuplot_commands += 'set xrange [' + str(x) + ':' + str(y) + ']'
#    self.add(gen_curve(element, 'pnp_queue_hold', 'Pointer_based_Navigation_piles', 'mixed pile', 'navigation_pile', log_i, log_k, k))
    self.add(gen_curve(element, 'pnp_queue_hold', 'Index_based_Navigation_piles', 'index pile', 'navigation_pile', log_i, log_k, k))
    self.add(gen_curve(element, 'pnp_queue_hold', 'Packed_Index_based_Navigation_piles', 'compact pile', 'navigation_pile', log_i, log_k, k))
    self.add(gen_curve(element, 'pnp_queue_hold', 'All_Pointer_based_Navigation_piles', 'pointer-based pile', 'navigation_pile', log_i, log_k, k))
    self.add(gen_curve(element, 'bhr_queue_hold', 'Binary_heap_using_reference', 'referent heap', 'binary_heap_ref', log_i, log_k, k))
    self.add(std_curve(element, 'sgi_queue_hold', 'SGI', 'implicit heap', log_i, log_k, k))
    self.gnuplot_commands += """
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
set logscale x
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(
#    task = plot('double', 10, 10, 100000),
#    task = plot('double', 10, 18, 100000),
    task = plot('double', 10, 23, 100000),
    runner = benchmark.gnuplot_runner
  )
