#include <queue> // defines std::priority_queue
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n) {
    a = container(n, element(n));
    b = container();
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());

    std::priority_queue<element, container, ordering> 
      pq(less, a);
  }
  void dual() {
    random_sequence(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
  container b;
  ordering less;
};

