/*
Benchmark the make_heap() function

Author: Jyrki Katajainen
Email: jyrki@diku.dk
$Revision: 1.1 $
$Date: 2003/10/29 23:08:45 $

*/

// The heap_policy class must be included by the driver

#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  int d,
  typename element, 
  typename ordering,
  typename container,
  typename position,
  typename policy
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    a = container(n, element());
    less = ordering();
    p = policy(a.end() - a.begin());
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    make_heap<d, position, ordering, policy>(a.begin(), less, p);
  }
  void dual() {
    random_sequence(a.begin(), a.end());
    do_nothing<void, position, ordering, policy>(a.begin(), less, p);
  }
private:
  unsigned int n;
  container a;
  ordering less;
  policy p;
};

