/*
Benchmark the Sander binary heap function
*/

#include "do_nothing.c++" // defines do_nothing()
#include <climits> // defines INT_MAX
#include "heap2.h"

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
  }

#define rand32() (ran32State = 1664525 * ran32State + 1013904223)
#define getRandom() ((rand32()), (int)(ran32State >> 2))

#define HTYPE Heap2<int, int> 
#define HINIT heap(INT_MAX, -INT_MAX, n)

  inline void onePass(HTYPE& heap, int n)  { 
    int j, newElem, k, v;
    double insertSum=0, deleteSum=0;
    static int ran32State = 42 << 20;
    
    for (j = 0;  j < n;  j++) {   
      newElem = getRandom();
      heap.insert(newElem, j);
      
      heap.deleteMin(&k, &v);
      
      newElem = getRandom();
      heap.insert(newElem, j + 1);
    }
    
    for (j = 0;  j < n;  j++) {   
      heap.deleteMin(&k, &v);
      
      newElem = getRandom();
      heap.insert(newElem, j);
      
      heap.deleteMin(&k, &v);
    }
  }


  void primal() {
    HTYPE HINIT;
    onePass(heap, n);
  }
  
  void dual() {
    HTYPE HINIT;
    do_nothing<void, HTYPE&, unsigned int>(heap, n);
  }
private:
  unsigned int n;
};

