/*
Benchmark  the Sander heap_sort() function
*/

#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()
#include <climits> // defines INT_MAX
#include "heap2.h"

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    a = container(n, element());
  }

  void primal() {
    random_sequence(a.begin(), a.end());

    Heap2<int, int> heap(INT_MAX, -INT_MAX, n);
    for (position i = a.begin(); i != a.end(); ++i) {
      heap.insert(element(*i), 0); 
    }
    int k, v;
    int s = heap.getSize();
    while (s > 0) {
      heap.deleteMin(&k, &v);
      s = s - 1;
    }
  }
  void dual() {
      random_sequence(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
  ordering less;
};

