#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    d = container(3 * n, element());
    h = container(n, element());
    less = ordering();
  }

  void primal() {
    random_sequence(d.begin(), d.end());
    for (int i = 0; i < n; ++i) {
      h[i] = d[2 * i];
      std::push_heap(h.begin(), h.begin() + i + 1, less);
      std::pop_heap(h.begin(), h.begin() + i + 1, less);
      // now size i
      h[i] = d[2 * i + 1];
      std::push_heap(h.begin(), h.begin() + i + 1, less);
      // now size i + 1
    }
    for (int i = n; i > 0; --i) {
      std::pop_heap(h.begin(), h.begin() + i, less);
      h[i - 1] = d[3 * n - i];
      std::push_heap(h.begin(), h.begin() + i, less);
      // now size i
      std::pop_heap(h.begin(), h.begin() + i, less);
      // now size i - 1
    }
  }

  void dual() {
    // The same without pop()'s and push()'s
    random_sequence(d.begin(), d.end());
    for (int i = 0; i < n; ++i) {
      h[i] = d[2 * i];
      h[i] = d[2 * i + 1];
    }
    for (int i = n; i > 0; --i) {
      h[i - 1] = d[3 * n - i];
    }
  }
private:
  unsigned int n;
  container h; // heap
  container d; // data
  ordering less;
};

