/*
Benchmark the make_heap() function

Author: Jyrki Katajainen
Email: jyrki@diku.dk
$Revision: 1.1 $
$Date: 2003/12/05 01:10:44 $

*/


#include <algorithm> // defines std::make_heap
#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    a = container(n, element());
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    std::make_heap<position, ordering>(a.begin(), a.end(), less);
  }
  void dual() {
    random_sequence(a.begin(), a.end());
    do_nothing<void, position, position, ordering>(a.begin(), a.end(), less);
  }
private:
  unsigned int n;
  container a;
  ordering less;
};

