import benchmark
import os
from benchmark_curve_case_compare_log import *

class sort_plot(benchmark.plot_suite):
  def __init__(self, element, log_i, log_k):
    benchmark.plot_suite.__init__(self)
    self.title = 'Efficiency of various sorting functions for random integers using an expensive ordering function' 
    self.xlabel = 'n'
    self.ylabel = 'Execution time per element [in nanoseconds]'
    self.add(heapsort_curve(element, 'heapsort', 2, 'In-place-2-policy', 'Bottom-up', log_i, log_k))
    self.add(heapsort_curve(element, 'heapsort', 2, 'In-place-2-policy', 'Bottom-up-Binary-search', log_i, log_k))
    self.add(heapsort_curve(element, 'heapsort', 2, 'In-place-2-policy', 'Exp-Binary-search', log_i, log_k))
    self.add(heapsort_curve(element, 'heapsort', 2, 'In-place-2-policy', 'Bottom-up_move-saving', log_i, log_k))
    self.add(heapsort_curve(element, 'heapsort', 2, 'In-place-2-policy', 'Two-Level-Bottom-up', log_i, log_k))
    self.add(stdsort_curve(element, 'sort', 'SGI', log_i, log_k))
    self.add(stdsort_curve(element, 'partial_sort', 'SGI', log_i, log_k))
    self.gnuplot_commands += """
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
set logscale x
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(
    task = sort_plot('int', 10, 20),
    runner = benchmark.gnuplot_runner
  )
