#include <cstdlib> // defines std::size_t
#include <iterator> // defines std::iterator_traits
#include <vector> // defines std::vector<byte>

template <int d, typename position, typename ordering>
class heap_policy {
public: 
  typedef typename std::iterator_traits<position>::difference_type index;
  typedef typename std::iterator_traits<position>::difference_type level;
  typedef typename std::iterator_traits<position>::value_type element;

  heap_policy(index n = 0);

  bool is_root(index) const;
  bool is_first_child(index) const;
  index size() const;
  level depth(index) const;
  index root() const;
  index leftmost_node(level) const;
  index last_leaf() const;
  index first_child(index) const;
  index parent(index) const;
  index ancestor(index, level, level) const;
  index top_some_absent(position, index, const ordering&) const;
  index top_all_present(position, index, const ordering&) const;
  void update(position, index, const element&);
  void erase_last_leaf();
  void insert_new_leaf();

private:
  index n;
  index l;
};


template <typename position, typename ordering>
class heap_policy <4, position, ordering> {
public: 
  typedef typename std::iterator_traits<position>::difference_type index;
  typedef typename std::iterator_traits<position>::difference_type level;
  typedef typename std::iterator_traits<position>::value_type element;

  heap_policy(index n = 0);

  bool is_root(index) const;
  bool is_first_child(index) const;
  index size() const;
  level depth(index) const;
  index root() const;
  index leftmost_node(level) const;
  index last_leaf() const;
  index first_child(index) const;
  index parent(index) const;
  index ancestor(index, level, level) const;
  index top_some_absent(position, index, const ordering&) const;
  index top_all_present(position, index, const ordering&) const;
  void update(position, index, const element&);
  void erase_last_leaf();
  void insert_new_leaf();

private:
  index n;
  index l;
};

