template <typename random_access_iterator>
void global_moves ( 
  random_access_iterator first,
  random_access_iterator past_the_end,
  unsigned long seed = 4321
) {
  random_access_iterator p;
  random_access_iterator q;
  std::srand(seed);
  for (q = past_the_end - 1; q > first; --q) {
    p = first + (std::rand() % (q - first + 1));
    std::swap(*p, *q);
  }
}

template <typename random_access_iterator>
void special_cost_for_global_moves ( 
  random_access_iterator first,
  random_access_iterator past_the_end,
  unsigned long seed = 4321
) {
  random_access_iterator p;
  random_access_iterator q;
  std::srand(seed);
  for (q = past_the_end - 1; q > first; --q) {
    p = first + (std::rand() % (q - first + 1));
  }
}
