#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the cachemiss ratio of the inpluko_benchmark program.
The benchmark is executed on the host 'cphstl.projektlab.diku.dk'.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class inpluko_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.computer = 'cphstl.projektlab.diku.dk'
    self.papi_path = '/usr/local/papi'
    self.papitype = 'single'
    self.include_files.extend(['inpluko.h','inpluko_benchmark.c++'])
    self.constructor_call = 'inpluko(' + str(n) + ')'
    self.connection_protocol = 'ssh'
    self.transfer_protocol = 'scp'
    self.dual_exists = 0
    self.driver_file = self.generate_execution_mem_driver()

  def output(self):
    cache_misses = string.split(self.driver_output,";")[2]
    cache_accesses = string.split(self.driver_output,";")[3]
    result = float(cache_misses)/float(cache_accesses)
    return (self.n, result)

class inpluko_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'ratio'
    self.add(inpluko_case(10000))    
    self.add(inpluko_case(20000))    
    self.add(inpluko_case(30000))    
    self.add(inpluko_case(40000))    
    self.add(inpluko_case(50000))    

class inpluko_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'Inplace merge by ukkonen'
    self.xlabel = 'n'
    self.ylabel = 'Cache miss ratio'
    self.add(inpluko_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = inpluko_plot(), runner = benchmark.gnuplot_runner)
