#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the number of times the 'compare' function is called during execution of the inpluko_benchmark program.
The benchmark is executed on the host 'cphstl.projektlab.diku.dk'.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class merge_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.computer = 'cphstl.projektlab.diku.dk'
    self.counted_function = 'compare'
    self.include_files.extend(['inpluko.h','inpluko_benchmark.c++'])
    self.constructor_call = 'inpluko(' + str(n) + ')'
    self.connection_protocol = 'ssh'
    self.transfer_protocol = 'scp'
    self.driver_file = self.generate_function_call_count_driver()

  def output(self):
    return (self.n, string.split(self.driver_output)[3])

class merge_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = ''
    self.add(merge_case(10000))
    self.add(merge_case(20000))
    self.add(merge_case(30000))
    self.add(merge_case(40000))
    self.add(merge_case(50000))

class merge_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'calls to compare'
    self.xlabel = 'n'
    self.ylabel = 'Number of calls to compare'
    self.add(merge_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = merge_plot(), runner = benchmark.gnuplot_runner)
