#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the execution time of the spin_benchmark program.
The benchmark is executed on the host 'cphstl.projektlab.diku.dk'.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class remotespin_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.computer = 'cphstl.projektlab.diku.dk'
    self.gateway = 'skade.diku.dk'
    self.compiler_options.extend(['-O3'])
    self.include_files.extend(['spin_benchmark.c++'])
    self.constructor_call = 'spin(' + str(n) + ')'
    self.connection_protocol = 'ssh'
    self.transfer_protocol = 'scp'
    self.time_unit = 'ns'
    self.driver_file = self.generate_cpu_time_driver()

  def output(self):
    return (self.n, float(self.driver_output) / self.n)

class remotespin_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'simple spin'
    for k in range(100, 101):
      self.add(remotespin_case(k))

class remotespin_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'remote spin'
    self.xlabel = 'n'
    self.ylabel = 'Execution time per iteration [in ns]'
    self.add(fjernspin_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = remotespin_plot(), runner = benchmark.gnuplot_runner)
